const Immutable = require('immutable')

module.exports = {
  constructors: {
    empty () {
      return Immutable.List()
    },
    nativeArray (items) {
      return Immutable.List(items)
    },
    set (set) {
      return Immutable.List(set)
    }
  },
  conversions: {
    nativeArray (list) {
      return list.toJS()
    }
  },
  modifications: {
    push (me, item) {
      return me.push(item)
    },
    pop (me) {
      return me.pop()
    },
    unshift (me, item) {
      return me.unshift(item)
    },
    shift (me) {
      return me.shift()
    },
    concat (me, other) {
      return me.concat(other)
    }
  },
  searches: {
    get (me, index) {
      return me.get(index)
    }
  },
  comparisons: {
    equals (me, other) {
      return me.equals(other)
    }
  }
}
