const Immutable = require('immutable')

module.exports = {
  constructors: {
    empty () {
      return Immutable.Set()
    },
    nativeArray (items) {
      return Immutable.Set(items)
    },
    list (list) {
      return Immutable.Set(list)
    }
  },
  conversions: {
    nativeArray (set) {
      return set.toJS()
    }
  },
  modifications: {
    add (me, item) {
      return me.add(item)
    },
    delete (me, item) {
      return me.delete(item)
    },
    union (me, other) {
      return me.union(other)
    },
    intersect (me, other) {
      return me.intersect(other)
    },
    difference (me, other) {
      return me.subtract(other)
    }
  },
  searches: {
    member (me, item) {
      return me.has(item)
    }
  },
  comparisons: {
    subsetOf (me, other) {
      return other.isSubset(me)
    },
    equals (me, other) {
      return me.equals(other)
    }
  }
}
